diff --git a/django/contrib/admin/templates/admin/index.html b/django/contrib/admin/templates/admin/index.html
index a8ced39..b4b6ef7 100644
--- a/django/contrib/admin/templates/admin/index.html
+++ b/django/contrib/admin/templates/admin/index.html
@@ -14,7 +14,7 @@
 
 {% if app_list %}
     {% for app in app_list %}
-        <div class="module">
+        <div class="module" id="app-{{ app.name }}-module">
         <table summary="{% blocktrans with name=app.name %}Models available in the {{ name }} application.{% endblocktrans %}">
         <caption><a href="{{ app.app_url }}" class="section">{% blocktrans with name=app.name %}{{ name }}{% endblocktrans %}</a></caption>
         {% for model in app.models %}
diff --git a/tests/regressiontests/admin_individual_ids/__init__.py b/tests/regressiontests/admin_individual_ids/__init__.py
new file mode 100644
index 0000000..e69de29
diff --git a/tests/regressiontests/admin_individual_ids/admin.py b/tests/regressiontests/admin_individual_ids/admin.py
new file mode 100644
index 0000000..330361c
--- /dev/null
+++ b/tests/regressiontests/admin_individual_ids/admin.py
@@ -0,0 +1,7 @@
+from django.contrib import admin
+
+from models import *
+
+site = admin.AdminSite(name="admin")
+
+site.register(Poll)
diff --git a/tests/regressiontests/admin_individual_ids/fixtures/admin-views-users.xml b/tests/regressiontests/admin_individual_ids/fixtures/admin-views-users.xml
new file mode 100644
index 0000000..aba8f4a
--- /dev/null
+++ b/tests/regressiontests/admin_individual_ids/fixtures/admin-views-users.xml
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="utf-8"?>
+<django-objects version="1.0">
+    <object pk="100" model="auth.user">
+        <field type="CharField" name="username">super</field>
+        <field type="CharField" name="first_name">Super</field>
+        <field type="CharField" name="last_name">User</field>
+        <field type="CharField" name="email">super@example.com</field>
+        <field type="CharField" name="password">sha1$995a3$6011485ea3834267d719b4c801409b8b1ddd0158</field>
+        <field type="BooleanField" name="is_staff">True</field>
+        <field type="BooleanField" name="is_active">True</field>
+        <field type="BooleanField" name="is_superuser">True</field>
+        <field type="DateTimeField" name="last_login">2007-05-30 13:20:10</field>
+        <field type="DateTimeField" name="date_joined">2007-05-30 13:20:10</field>
+        <field to="auth.group" name="groups" rel="ManyToManyRel"></field>
+        <field to="auth.permission" name="user_permissions" rel="ManyToManyRel"></field>
+    </object>
+</django-objects>
diff --git a/tests/regressiontests/admin_individual_ids/models.py b/tests/regressiontests/admin_individual_ids/models.py
new file mode 100644
index 0000000..bb8e8b4
--- /dev/null
+++ b/tests/regressiontests/admin_individual_ids/models.py
@@ -0,0 +1,8 @@
+"""
+Testing of individual ids for models in Admin.
+
+"""
+from django.db import models
+
+class Poll(models.Model):
+    name = models.CharField(max_length=40)
diff --git a/tests/regressiontests/admin_individual_ids/tests.py b/tests/regressiontests/admin_individual_ids/tests.py
new file mode 100644
index 0000000..c7959de
--- /dev/null
+++ b/tests/regressiontests/admin_individual_ids/tests.py
@@ -0,0 +1,23 @@
+from __future__ import absolute_import
+
+from django.test import TestCase
+
+
+class TestIndividualIds(TestCase):
+    urls = "regressiontests.admin_individual_ids.urls"
+    fixtures = ['admin-views-users.xml']
+
+    def setUp(self):
+        self.change_url = '/admin/'
+
+        result = self.client.login(username='super', password='secret')
+        self.assertEqual(result, True)
+
+    def tearDown(self):
+        self.client.logout()
+
+    def test_are_ids_ok(self):
+        """Test if the ids are there and if they are right."""
+        response = self.client.get(self.change_url)
+        self.assertContains(response, '<div class="module" id="app-Admin_Individual_Ids-module">')
+
diff --git a/tests/regressiontests/admin_individual_ids/urls.py b/tests/regressiontests/admin_individual_ids/urls.py
new file mode 100644
index 0000000..cf18ef9
--- /dev/null
+++ b/tests/regressiontests/admin_individual_ids/urls.py
@@ -0,0 +1,10 @@
+from __future__ import absolute_import
+
+from django.conf.urls import patterns, include
+
+from . import admin
+
+
+urlpatterns = patterns('',
+    (r'^admin/', include(admin.site.urls)),
+)