diff --git a/django/contrib/auth/tokens.py b/django/contrib/auth/tokens.py
index a75ef61..735e95b 100644
--- a/django/contrib/auth/tokens.py
+++ b/django/contrib/auth/tokens.py
@@ -1,4 +1,4 @@
-from datetime import date
+from datetime import date, timedelta
 from django.conf import settings
 from django.utils.http import int_to_base36, base36_to_int
 from django.utils.crypto import constant_time_compare, salted_hmac
@@ -52,8 +52,12 @@ class PasswordResetTokenGenerator(object):
         # invalid as soon as it is used.
         # We limit the hash to 20 chars to keep URL short
         key_salt = "django.contrib.auth.tokens.PasswordResetTokenGenerator"
+
+        # Ensure consistent timestamps across DB backends
+        last_login = user.last_login - timedelta(microseconds=user.last_login.microsecond)
+
         value = (unicode(user.id) + user.password +
-                unicode(user.last_login) + unicode(timestamp))
+                unicode(last_login) + unicode(timestamp))
         hash = salted_hmac(key_salt, value).hexdigest()[::2]
         return "%s-%s" % (ts_b36, hash)
 
diff --git a/django/core/management/commands/loaddata.py b/django/core/management/commands/loaddata.py
index 7b0e30f..0fe20ec 100644
--- a/django/core/management/commands/loaddata.py
+++ b/django/core/management/commands/loaddata.py
@@ -5,8 +5,10 @@ from __future__ import with_statement
 import sys
 import os
 import gzip
+import warnings
 import zipfile
 from optparse import make_option
+import MySQLdb
 
 from django.conf import settings
 from django.core import serializers
@@ -179,8 +181,10 @@ class Command(BaseCommand):
                                             loaded_objects_in_fixture += 1
                                             models.add(obj.object.__class__)
                                             try:
-                                                obj.save(using=using)
-                                            except (DatabaseError, IntegrityError), e:
+                                                with warnings.catch_warnings():
+                                                    warnings.filterwarnings('error', category=MySQLdb.Warning)
+                                                    obj.save(using=using)
+                                            except (DatabaseError, IntegrityError, Warning), e:
                                                 msg = "Could not load %(app_label)s.%(object_name)s(pk=%(pk)s): %(error_msg)s" % {
                                                         'app_label': obj.object._meta.app_label,
                                                         'object_name': obj.object._meta.object_name,
diff --git a/tests/modeltests/fixtures/tests.py b/tests/modeltests/fixtures/tests.py
index 54ce470..46d231f 100644
--- a/tests/modeltests/fixtures/tests.py
+++ b/tests/modeltests/fixtures/tests.py
@@ -263,7 +263,7 @@ class FixtureLoadingTests(TestCase):
         new_io = StringIO.StringIO()
         management.call_command('loaddata', 'invalid.json', verbosity=0, stderr=new_io, commit=False)
         output = new_io.getvalue().strip().split('\n')
-        self.assertRegexpMatches(output[-1], "IntegrityError: Could not load fixtures.Article\(pk=1\): .*$")
+        self.assertRegexpMatches(output[-1], "(IntegrityError|Warning): Could not load fixtures.Article\(pk=1\): .*$")
 
     def test_loading_using(self):
         # Load db fixtures 1 and 2. These will load using the 'default' database identifier explicitly
diff --git a/tests/regressiontests/admin_scripts/tests.py b/tests/regressiontests/admin_scripts/tests.py
index 8580e36..b85f5d3 100644
--- a/tests/regressiontests/admin_scripts/tests.py
+++ b/tests/regressiontests/admin_scripts/tests.py
@@ -864,14 +864,14 @@ class ManageAlternateSettings(AdminScriptTestCase):
         "alternate: manage.py builtin commands work with settings provided as argument"
         args = ['sqlall','--settings=alternate_settings', 'admin_scripts']
         out, err = self.run_manage(args)
-        self.assertOutput(out, 'CREATE TABLE "admin_scripts_article"')
+        self.assertRegexpMatches(out,  'CREATE TABLE (`|")admin_scripts_article(`|")')
         self.assertNoOutput(err)
 
     def test_builtin_with_environment(self):
         "alternate: manage.py builtin commands work if settings are provided in the environment"
         args = ['sqlall','admin_scripts']
         out, err = self.run_manage(args,'alternate_settings')
-        self.assertOutput(out, 'CREATE TABLE "admin_scripts_article"')
+        self.assertRegexpMatches(out,  'CREATE TABLE (`|")admin_scripts_article(`|")')
         self.assertNoOutput(err)
 
     def test_builtin_with_bad_settings(self):
diff --git a/tests/regressiontests/i18n/tests.py b/tests/regressiontests/i18n/tests.py
index fc69d9c..6180b49 100644
--- a/tests/regressiontests/i18n/tests.py
+++ b/tests/regressiontests/i18n/tests.py
@@ -21,8 +21,9 @@ from django.utils.translation import (ugettext, ugettext_lazy, activate,
     deactivate, gettext_lazy, pgettext, npgettext, to_locale,
     get_language_info, get_language, get_language_from_request)
 
+# Keep as a * import because of conditional imports in .commands.tests
+from .commands.tests import *
 
-from .commands.tests import NoWrapExtractorTests, IgnoredExtractorTests, MessageCompilationTests, PoFileTests, BasicExtractorTests, JavascriptExtractorTests, CopyPluralFormsExtractorTests, SymlinkExtractorTests, ExtractorTests
 from .contenttypes.tests import ContentTypeTests
 from .forms import I18nForm, SelectDateForm, SelectDateWidget, CompanyForm
 from .models import Company, TestModel
diff --git a/tests/regressiontests/multiple_database/tests.py b/tests/regressiontests/multiple_database/tests.py
index 741cba4..b8fab2e 100644
--- a/tests/regressiontests/multiple_database/tests.py
+++ b/tests/regressiontests/multiple_database/tests.py
@@ -17,6 +17,18 @@ from .models import Book, Person, Pet, Review, UserProfile
 class QueryTestCase(TestCase):
     multi_db = True
 
+    def setUp(self):
+        # Disable constraint checking
+        for connection_name in connections:
+            connection = connections[connection_name] 
+            connection.disable_constraint_checking() 
+
+    def tearDown(self):
+        # Re-enable constraint checking 
+        for connection_name in connections: 
+            connection = connections[connection_name] 
+            connection.enable_constraint_checking()
+
     def test_db_selection(self):
         "Check that querysets will use the default database by default"
         self.assertEqual(Book.objects.db, DEFAULT_DB_ALIAS)
@@ -976,10 +988,20 @@ class RouterTestCase(TestCase):
         self.old_routers = router.routers
         router.routers = [TestRouter()]
 
+        # Disable constraint checking
+        for connection_name in connections:
+            connection = connections[connection_name] 
+            connection.disable_constraint_checking() 
+
     def tearDown(self):
         # Restore the 'other' database as an independent database
         router.routers = self.old_routers
 
+        # Re-enable constraint checking 
+        for connection_name in connections: 
+            connection = connections[connection_name] 
+            connection.enable_constraint_checking()
+
     def test_db_selection(self):
         "Check that querysets obey the router for db suggestions"
         self.assertEqual(Book.objects.db, 'other')
@@ -1695,9 +1717,19 @@ class SignalTests(TestCase):
     def setUp(self):
         self.old_routers = router.routers
 
+        # Disable constraint checking
+        for connection_name in connections:
+            connection = connections[connection_name] 
+            connection.disable_constraint_checking() 
+
     def tearDown(self):
         router.routers = self.old_routers
 
+        # Re-enable constraint checking 
+        for connection_name in connections: 
+            connection = connections[connection_name] 
+            connection.enable_constraint_checking()
+
     def _write_to_other(self):
         "Sends all writes to 'other'."
         router.routers = [WriteToOtherRouter()]